# In debian, folloing packages are used:
#   poppler-utils pdftk imagemagick ffmpeg.
#
# sudo apt-get install poppler-utils pdftk imagemagick ffmpeg
#
require "numru/ggraph"
include NumRu

pardir = "../Earth_T21L26"

vnames_ty      = [ "SurfTemp", "SurfAlbedo", "Rain", "Snow", "PRCP" ]
vnames_xy      = [ "SurfTemp", "SurfAlbedo", "Rain", "Snow", "PRCP" ]
vnames_vint_xy = [ "QH2OVap", "QH2OLiq", "QH2OSol", "QH2OLiq+QH2OSol" ]
vnames_yp      = [ "U", "AngMom", "V", "MSF", "Temp", "QH2OVap", "QH2OLiq", "QH2OSol", "QH2OLiq+QH2OSol" ]


figdir = "figs"


if Dir.exist?(pardir) then
else
  print "Directory, ", pardir, ", does not exist.\n"
  exit
end
if Dir.exist?(figdir) then
else
  print "Directory, ", figdir, ", does not exist.\n"
  exit
end


ENV['SW_LSYSFNT'] = 'true'
ENV['SW_FONTNAME'] = "Helvetica"

iws = ( ARGV[0] || (puts ' WORKSTATION ID (I)  ? ;'; DCL::sgpwsn; gets)).to_i

# ty (time-lat)
com = "ruby disp_v1_yhflx.rb " + iws.to_s + " " + pardir
print com, "\n"
system( com )
if iws == 2 then
  figfile = "fig_yhflx.pdf"
  com = "mv dcl.pdf" + " " + figdir + "/" + figfile
  print com, "\n"
  system( com )
  #
  com = "convert " +figdir+"/"+figfile + " -rotate 90 \\( +clone -alpha opaque -fill white -colorize 100% \\) +swap -geometry +0+0 -compose Over -composite -alpha off " + figdir+"/"+figfile.sub(/.pdf/, ".png")
  print com, "\n"
  system( com )
end


# ty (time-lat)
vnames_ty.each do |vname|
  com = "ruby disp_v1_ty.rb " + iws.to_s + " " + pardir + " " + vname
  print com, "\n"
  system( com )
  if iws == 2 then
    figfile = "fig_ty_" + vname + ".pdf"
    com = "mv dcl.pdf" + " " + figdir + "/" + figfile
    print com, "\n"
    system( com )
    #
#    com = "pstoimg -flip r270 " + figdir + "/" + figfile
#    com = "convert -rotate 90 " + figdir + "/" + figfile + " " + figdir + "/" + figfile.sub(/.pdf/, ".png")
    com = "convert " +figdir+"/"+figfile + " -rotate 90 \\( +clone -alpha opaque -fill white -colorize 100% \\) +swap -geometry +0+0 -compose Over -composite -alpha off " + figdir+"/"+figfile.sub(/.pdf/, ".png")
    print com, "\n"
    system( com )
  end
end


# xy (lon-lat) annual mean
vnames_xy.each do |vname|
  com = "ruby disp_v1_xy.rb " + iws.to_s + " " + pardir + " " + vname
  print com, "\n"
  system( com )
  if iws == 2 then
    figfile = "fig_xy_am_" + vname + ".pdf"
    com = "mv dcl.pdf" + " " + figdir + "/" + figfile
    print com, "\n"
    system( com )
    #
#    com = "pstoimg -flip r270 " + figdir + "/" + figfile
#    com = "convert -rotate 90 " + figdir + "/" + figfile + " " + figdir + "/" + figfile.sub(/.pdf/, ".png")
    com = "convert " +figdir+"/"+figfile + " -rotate 90 \\( +clone -alpha opaque -fill white -colorize 100% \\) +swap -geometry +0+0 -compose Over -composite -alpha off " + figdir+"/"+figfile.sub(/.pdf/, ".png")
    print com, "\n"
    system( com )
  end
end


# xy (lon-lat) monthly mean
vnames_xy.each do |vname|
  com = "ruby disp_v1_xy.rb " +
        iws.to_s + " " + pardir + " " + vname + " month"
  print com, "\n"
  system( com )
  if iws == 2 then
    figfile = "fig_xy_mm_" + vname + ".pdf"
    com = "mv dcl.pdf" + " " + figdir + "/" + figfile
    print com, "\n"
    system( com )
    #
    com = "bash anim-loop_v2.sh " + figdir + "/" + figfile
    print com, "\n"
    system( com )
    #
    com = "rm -f figs-png/*.png figs-pdf/*.pdf"
    print com, "\n"
    system( com )
    #
    figfile = "fig_xy_mm_" + vname + ".mp4"
    com = "mv anim.mp4" + " " + figdir + "/" + figfile
    print com, "\n"
    system( com )
  end
end


# vertical integrated xy (lon-lat) annual mean
vnames_vint_xy.each do |vname|
  com = "ruby disp_v1_vint_xy.rb " +
        iws.to_s + " " + pardir + " " + vname
  print com, "\n"
  system( com )
  if iws == 2 then
    figfile = "fig_xy_am_" + vname + ".pdf"
    com = "mv dcl.pdf" + " " + figdir + "/" + figfile
    print com, "\n"
    system( com )
    #
    com = "convert " +figdir+"/"+figfile + " -rotate 90 \\( +clone -alpha opaque -fill white -colorize 100% \\) +swap -geometry +0+0 -compose Over -composite -alpha off " + figdir+"/"+figfile.sub(/.pdf/, ".png")
    print com, "\n"
    system( com )
  end
end

# vertical integrated xy (lon-lat) monthly mean
vnames_vint_xy.each do |vname|
  com = "ruby disp_v1_vint_xy.rb " +
        iws.to_s + " " + pardir + " " + vname + " month"
  print com, "\n"
  system( com )
  if iws == 2 then
    figfile = "fig_xy_mm_" + vname + ".pdf"
    com = "mv dcl.pdf" + " " + figdir + "/" + figfile
    print com, "\n"
    system( com )
    #
    com = "bash anim-loop_v2.sh " + figdir + "/" + figfile
    print com, "\n"
    system( com )
    #
    com = "rm -f figs-png/*.png figs-pdf/*.pdf"
    print com, "\n"
    system( com )
    #
    figfile = "fig_xy_mm_" + vname + ".mp4"
    com = "mv anim.mp4" + " " + figdir + "/" + figfile
    print com, "\n"
    system( com )
  end
end

["lin", "log"].each do |yaxis|

  # yplin (lat-p(lin)) annual mean
  vnames_yp.each do |vname|
    com = "ruby disp_v1_yp.rb " +
          iws.to_s + " " + pardir + " " + vname + " " + yaxis
    print com, "\n"
    system( com )
    if iws == 2 then
      figfile = "fig_yp" + yaxis + "_am_" + vname + ".pdf"
      com = "mv dcl.pdf" + " " + figdir + "/" + figfile
      print com, "\n"
      system( com )
      #
      com = "convert " +figdir+"/"+figfile + " -rotate 90 \\( +clone -alpha opaque -fill white -colorize 100% \\) +swap -geometry +0+0 -compose Over -composite -alpha off " + figdir+"/"+figfile.sub(/.pdf/, ".png")
      print com, "\n"
      system( com )
    end
  end

  # yplin (lat-p) monthly mean
  vnames_yp.each do |vname|
    com = "ruby disp_v1_yp.rb " + 
          iws.to_s + " " + pardir + " " + vname + " " + yaxis + " month"
    print com, "\n"
    system( com )
    if iws == 2 then
      figfile = "fig_yp" + yaxis + "_mm_" + vname + ".pdf"
      com = "mv dcl.pdf" + " " + figdir + "/" + figfile
      print com, "\n"
      system( com )
      #
      com = "bash anim-loop_v2.sh " + figdir + "/" + figfile
      print com, "\n"
      system( com )
      #
      com = "rm -f figs-png/*.png figs-pdf/*.pdf"
      print com, "\n"
      system( com )
      #
      figfile = "fig_yp" + yaxis + "_mm_" + vname + ".mp4"
      com = "mv anim.mp4" + " " + figdir + "/" + figfile
      print com, "\n"
      system( com )
    end
  end

end
