require "numru/ggraph"
require "./gp_dcpam_const_v1.0"
require "./gp_dcpam_methods_v1.0"
include NumRu

pardir="Earth_SO_LO_NoSI_NoO3_LandAlb0.2_Yr360d_CircOrb_Obl23.4_RotPeriod0001_T021L26"

DaysInAYear = DaysOfMonth.sum

if ARGV.size == 3 then
  pardir   = ARGV[1]
  vnames   = ARGV[2]
  meantype = "year"
elsif ARGV.size == 4 then
  pardir   = ARGV[1]
  vnames   = ARGV[2]
  meantype = ARGV[3]
else
  print "Unexpected number of arguments: ", ARGV.size, "\n"
  exit
end

dirname = Dir.glob( pardir+"/"+"????/" ).sort[-1]

vnames_bk = vnames

case vnames
when "QH2OVap" then
  cntmin = 0.0 ; cntmax = 5.0e2
when "QH2OLiq", "QH2OSol", "QH2OLiq+QH2OSol" then
  cntmin = 0.0 ; cntmax = 2.0
else
  print "Unexpected vname: ", vname, "\n"
  exit
end


vnames = vnames.split("+")
nvname = vnames.size
for i in 0..(nvname-1)
  vname = vnames[i]
#  print vname, "\n"
  #ncfn = pardir+"/????/"+vname+"_rank??????.nc"
  ncfn = dirname+"/"+vname+"_rank??????.nc"
  url = ncfn + "@" + vname
  if i == 0 then
    gphys = GPhys::IO.open_gturl( url )
  else
    gphys = gphys + GPhys::IO.open_gturl( url )
  end
end

#ncfn = pardir+"/????/"+"Ps"+"_rank??????.nc"
ncfn = dirname+"/"+"Ps"+"_rank??????.nc"
url = ncfn + "@" + "Ps"
gp_ps = GPhys::IO.open_gturl( url )

#ncfn = dirname+"/"+"Ps"+"_rank??????.nc"
ncfn = dirname+"/"+"Ps"+"_rank000000.nc"
url = ncfn + "@" + "sig_weight"
gp_sig_weight = GPhys::IO.open_gturl( url )


# gphys1 = ( gphys1.cut('time'=>time[ts]..time[te]).mean('time') * weight.reshape!(1,gphysw.shape[0]) ).sum(1).mean(0)

na_lon = gphys.coord('lon').val
na_lat = gphys.coord('lat').val
na_sig = gphys.coord('sig').val
na_time_in = gphys.coord('time').val

imax = na_lon.size
jmax = na_lat.size
kmax = na_sig.size
tmax = na_time_in.size

na_sig_weight = gp_sig_weight.val.reshape!(1,1,kmax)



iws = (ARGV[0] || (puts ' WORKSTATION ID (I)  ? ;'; DCL::sgpwsn; gets)).to_i
DCL.gropn(iws)

#DCL.sldiv('y',1,4)
DCL.sgpset('isub', 96)     # control character of subscription: '_' --> '`'
DCL.sgpset('lfull',true)
DCL.uzfact(0.6)            # font size
DCL.sgpset('lclip', true)  # clip graph
DCL.glpset('lmiss',true)   # missing value

#DCL.sgscmn(4)  # blue-cyan-white-yellow-red
#DCL.sgscmn(5)  # gray-scale
#DCL.sgscmn(14) # blue-white-red

#levels = [110,120,130,140,150,160,170,180,190,200,210,220,230,240]
#patterns = [10999,15999,20999,25999,30999,35999,40999,50999,60999,65999,70999,75999,80999,90999,95999]

gpout = gphys[true,true,0,0].copy
gpout[true,true] = 0.0
tmax_sl = 1000

case meantype
when "year" then
  nLoop = 1
when "month" then
  nLoop = DaysOfMonth.length
end

ts0 = - DaysInAYear * DataNumOfDay
te0 = -1

te  = ts0-1
for loop_index in 0..(nLoop-1)

  case meantype
  when "year" then
    nAve = DaysInAYear * DataNumOfDay
  when "month" then
    nAve = DaysOfMonth[loop_index] * DataNumOfDay
  end


  ts = te  + 1
  te = ts  + nAve-1
  te = [te0,te].min

  print "  loop_index: ", loop_index, ", ts: ", ts, ", te: ", te, "\n"

  for iloop in 0..((te-ts-1)/tmax_sl)
    ts_sl = ts + tmax_sl * iloop
    te_sl = ts_sl + tmax_sl - 1
    te_sl = [te_sl,te].min
#  print iloop, ", ", ts_sl, ", ", te_sl, "\n"

#    gpout = gpout +
#            ( gphys[true,true,true,ts_sl..te_sl] *
#              gp_ps[true,true,ts_sl..te_sl].val.reshape!(imax,jmax,1,te_sl-ts_sl+1) *
#              na_sig_weight ).sum(3).sum(2)
#    gpout = gpout +
#            integrate_vertical(
#              gp_sig_weight,
#              gp_ps.cut('time'=>na_time_in[ts_sl]..na_time_in[te_sl]),
#              gphys.cut('time'=>na_time_in[ts_sl]..na_time_in[te_sl]) ).sum(2)
    gpout = gpout +
            integrate_vertical(
              gp_sig_weight,
              gp_ps[true,true,ts_sl..te_sl],
              gphys[true,true,true,ts_sl..te_sl] ).sum(2)

  end
  gpout = gpout / ( te-ts+1 )

  GGraph.set_fig 'itr'=> 10, 'viewport'=>[0.1,0.9,0.2,0.6], 'window'=>[0,360,-90,90]
  if PlanetName == "Earth" then
    GGraph.set_map "coast_world"=>true, 'grid'=>false
  else
    GGraph.set_map "coast_world"=>false, 'grid'=>false
  end
  GGraph.set_axes('xlabelint'=>30)
  GGraph.set_axes('ylabelint'=>30)

  GGraph.tone    gpout, true , 'exchange'=>false,
                 'title'=>vnames_bk, 
                 'map_axes'=>true, 'annotate'=>false, 
                 'nlev'=>15, 'keep'=>true
#                 'min'=>cntmin, 'max'=>cntmax #, 'lev'=>levels, 'pat'=>patterns
#  GGraph.contour gpout, false, 'exchange'=>false,
#                 'nlev'=>15, 'keep'=>true
##                 'min'=>cntmin, 'max'=>cntmax #, 'lev'=>levels
  GGraph.color_bar

  if TopogNC.size > 0 then
    url = TopogNC + "@" + TopogName
    gp_topog = GPhys::IO.open_gturl( url )
    GGraph.contour gp_topog, false, 'exchange'=>false, 'lev'=>[0]
  end

  if nLoop > 1 then
    title = (loop_index+1).to_s + "/" + nLoop.to_s
    DCL::uxmttl('T', ' '  , 1.0)
    DCL::uxmttl('T', title, -1.0)
  end
end

DCL.grcls
