require "numru/ggraph"
include NumRu
require "./gp_dcpam_const_v1.0"
require "./gp_dcpam_methods_v1.0"

pardir ="."

vname  = "SurfTemp"
cntmin = 200.0 ; cntmax = 320.0
vname  = "SurfAlbedo"
cntmin =   0.0 ; cntmax =   0.6


DaysInAYear = DaysOfMonth.sum


if ARGV.size == 3 then
  pardir   = ARGV[1]
  vname    = ARGV[2]
  meantype = "year"
elsif ARGV.size == 4 then
  pardir   = ARGV[1]
  vname    = ARGV[2]
  meantype = ARGV[3]
else
  print "Unexpected number of arguments: ", ARGV.size, "\n"
  exit
end

case vname
when "SurfTemp" then
  cntmin = 200.0 ; cntmax = 320.0
when "SurfAlbedo" then
  cntmin =   0.0 ; cntmax =   0.6
when "Rain", "Snow", "PRCP" then
  cntmin =   0.0 ; cntmax =   1.5e-4
else
  print "Unexpected vname: ", vname, "\n"
  exit
end


ncfn = pardir+"/????/"+vname+"_rank??????.nc"
url = ncfn + "@" + vname
gphys = GPhys::IO.open_gturl( url )


na_time_in = gphys.coord('time').val


iws = (ARGV[0] || (puts ' WORKSTATION ID (I)  ? ;'; DCL::sgpwsn; gets)).to_i
DCL.gropn(iws)

#DCL.sldiv('y',1,4)
DCL.sgpset('isub', 96)     # control character of subscription: '_' --> '`'
DCL.sgpset('lfull',true)
DCL.uzfact(0.6)            # font size
DCL.sgpset('lclip', true)  # clip graph
DCL.glpset('lmiss',true)   # missing value

#DCL.sgscmn(4)  # blue-cyan-white-yellow-red
#DCL.sgscmn(5)  # gray-scale
#DCL.sgscmn(14) # blue-white-red

#levels = [110,120,130,140,150,160,170,180,190,200,210,220,230,240]
#patterns = [10999,15999,20999,25999,30999,35999,40999,50999,60999,65999,70999,75999,80999,90999,95999]


case meantype
when "year" then
  nLoop = 1
when "month" then
  nLoop = DaysOfMonth.length
end

ts0 = - DaysInAYear * DataNumOfDay
te0 = -1

te  = ts0-1
for loop_index in 0..(nLoop-1)

  case meantype
  when "year" then
    nAve = DaysInAYear * DataNumOfDay
  when "month" then
    nAve = DaysOfMonth[loop_index] * DataNumOfDay
  end


  ts = te  + 1
  te = ts  + nAve-1
  te = [te0,te].min

  print "  loop_index: ", loop_index, ", ts: ", ts, ", te: ", te, "\n"

  gpout = gphys.cut('time'=>na_time_in[ts]..na_time_in[te]).mean('time')
#  gpout = longmean_index( "time", ts, te, gphys )
#  gpout = longmean( "time", na_time_in[ts], na_time_in[te], gphys )

  GGraph.set_fig 'itr'=> 10, 'viewport'=>[0.1,0.9,0.2,0.6], 'window'=>[0,360,-90,90]
  if PlanetName == "Earth" then
    GGraph.set_map "coast_world"=>true, 'grid'=>false
  else
    GGraph.set_map "coast_world"=>false, 'grid'=>false
  end
  GGraph.set_axes('xlabelint'=>30)
  GGraph.set_axes('ylabelint'=>30)

  GGraph.tone    gpout, true , 'exchange'=>false,
                 'map_axes'=>true, 'annotate'=>false,
                 'nlev'=>15, 'keep'=>true
#                 'min'=>cntmin, 'max'=>cntmax #, 'lev'=>levels, 'pat'=>patterns
#  GGraph.contour gpout, false, 'exchange'=>false,
#                 'nlev'=>15, 'keep'=>true
##                 'min'=>cntmin, 'max'=>cntmax #, 'lev'=>levels
  GGraph.color_bar

  if TopogNC.size > 0 then
    url = TopogNC + "@" + TopogName
    gp_topog = GPhys::IO.open_gturl( url )
    GGraph.contour gp_topog, false, 'exchange'=>false, 'lev'=>[0]
  end

  if nLoop > 1 then
    title = (loop_index+1).to_s + "/" + nLoop.to_s
    DCL::uxmttl('T', ' '  , 1.0)
    DCL::uxmttl('T', title, -1.0)
  end
end

DCL.grcls
