require "numru/ggraph"
require "./gp_dcpam_const_v1.0"
require "./gp_dcpam_methods_v1.0"
include NumRu

pardir="."

plev = PLev

DaysInAYear = DaysOfMonth.sum

if ARGV.size == 4 then
  pardir   = ARGV[1]
  vnames   = ARGV[2]
  yaxis    = ARGV[3]
  meantype = "year"
elsif ARGV.size == 5 then
  pardir   = ARGV[1]
  vnames   = ARGV[2]
  yaxis    = ARGV[3]
  meantype = ARGV[4]
else
  print "Unexpected number of arguments: ", ARGV.size, "\n"
  exit
end

flag_cntlog = false
case yaxis
when "lin" then
  itr = 1
when "log" then
  itr = 2
  if vnames == "MSF" then
    flag_cntlog = true
  end
else
  print "Unexpected type of y axis: ", yaxis, "\n"
  exit
end

dirname = Dir.glob( pardir+"/"+"????/" ).sort[-1]

vnames_bk = vnames


case vnames
when "U" then
  cntmin = -20.0 ; cntmax = 60.0
when "AngMom" then
  cntmin = 0.0e0 ; cntmax = 3.0e0
when "V" then
  cntmin = -5.0 ; cntmax = 5.0
when "MSF" then
  cntmin = -1.0e1 ; cntmax = 1.0e1
when "Temp" then
  cntmin = 120.0 ; cntmax = 320.0
when "QH2OVap" then
  cntmin = 0.0 ; cntmax = 1.0e-2
when "QH2OLiq" then
  cntmin = 0.0 ; cntmax = 3.0e-5
when "QH2OSol" then
  cntmin = 0.0 ; cntmax = 3.0e-5
when "QH2OLiq+QH2OSol" then
  cntmin = 0.0 ; cntmax = 3.0e-5
else
  print "Unexpected vname: ", vname, "\n"
  exit
end


vnames = vnames.split("+")
nvname = vnames.size
for i in 0..(nvname-1)
  case vnames[i]
  when "AngMom" then
    vname = "U"
  when "MSF" then
    vname = "V"
  else
    vname = vnames[i]
  end
#  print vname, "\n"
  #ncfn = pardir+"/????/"+vname+"_rank??????.nc"
  ncfn = dirname+"/"+vname+"_rank??????.nc"
  url = ncfn + "@" + vname
  if i == 0 then
    gphys = GPhys::IO.open_gturl( url )
  else
    gphys = gphys + GPhys::IO.open_gturl( url )
  end
end

#ncfn = pardir+"/????/"+"Ps"+"_rank??????.nc"
ncfn = dirname+"/"+"Ps"+"_rank??????.nc"
url = ncfn + "@" + "Ps"
gp_ps = GPhys::IO.open_gturl( url )



iws = (ARGV[0] || (puts ' WORKSTATION ID (I)  ? ;'; DCL::sgpwsn; gets)).to_i
DCL.gropn(iws)

#DCL.sldiv('y',1,4)
DCL.sgpset('isub', 96)     # control character of subscription: '_' --> '`'
DCL.sgpset('lfull',true)
DCL.uzfact(0.6)            # font size
DCL.sgpset('lclip', true)  # clip graph
DCL.glpset('lmiss',true)   # missing value

#DCL.sgscmn(4)  # blue-cyan-white-yellow-red
#DCL.sgscmn(5)  # gray-scale
#DCL.sgscmn(14) # blue-white-red

#levels = [110,120,130,140,150,160,170,180,190,200,210,220,230,240]
#patterns = [10999,15999,20999,25999,30999,35999,40999,50999,60999,65999,70999,75999,80999,90999,95999]

na_lon     = gphys.coord('lon').val
na_lat     = gphys.coord('lat').val
na_sig     = gphys.coord('sig').val
na_time_in = gphys.coord('time').val

gp_sig = gphys.axis('sig').to_gphys

imax = na_lon.size
jmax = na_lat.size
kmax = na_sig.size
tmax = na_time_in.size


tmax_sl = 1000


case meantype
when "year" then
  nLoop = 1
when "month" then
  nLoop = DaysOfMonth.length
end

ts0 = - DaysInAYear * DataNumOfDay
te0 = -1

te  = ts0-1
for loop_index in 0..(nLoop-1)

  case meantype
  when "year" then
    nAve = DaysInAYear * DataNumOfDay
  when "month" then
    nAve = DaysOfMonth[loop_index] * DataNumOfDay
  end


  ts = te  + 1
  te = ts  + nAve-1
  te = [te0,te].min

  print "  loop_index: ", loop_index, ", ts: ", ts, ", te: ", te, "\n"

  for iloop in 0..((te-ts-1)/tmax_sl)
    ts_sl = ts + tmax_sl * iloop
    te_sl = ts_sl + tmax_sl - 1
    te_sl = [te_sl,te].min
#  print iloop, ", ", ts_sl, ", ", te_sl, "\n"

    # pickup part of GPhys object (array)
    gp_part    = gphys[true,true,true,ts_sl..te_sl].copy
    gp_ps_part = gp_ps[true,true,ts_sl..te_sl].copy


    gp_part_onplev = interpolate_on_p( plev, gp_ps_part, gp_part )

    if iloop == 0 then
      gpout = gp_part_onplev[true,true,true,0].copy
      gpout[true,true,true] = 0.0
      gp_mask = gpout.copy
      gp_mask[true,true,true] = 0
    end
    gpout = gpout + gp_part_onplev.sum('time')
    gp_mask[true,true,true] = gp_mask[true,true,true] +
                              gp_part_onplev.val.get_mask.to_f.sum(3)

  end
  gp_mask[ ( gp_mask.val.eq 0 ) ] = 1
  gpout = gpout / gp_mask

  gp_mask[true,true,true] = gpout.val.get_mask.to_f
  gp_mask = gp_mask.sum('lon')
  gp_mask[ ( gp_mask.val.eq 0 ) ] = 1
  gpout = gpout.sum('lon') / gp_mask

  case vnames[0]
  when "AngMom" then
    gpout = calc_absangmom( RPlanet, Omega, gpout, "lat", "pressure" )
    gpout = gpout * 1.0e-9
    gpout.units = "1e9 " + gpout.units.to_s
  when "MSF" then
    gpout = calc_msf( Grav, RPlanet, gpout, 'lat', 'pressure' )
    gpout = gpout * 1.0e-10
    gpout.units = "1e10 " + gpout.units.to_s
  end


  GGraph.set_fig 'itr'=> itr, 'viewport'=>[0.1,0.9,0.2,0.6], 'window'=>[-90,90,plev[0],plev[-1]]
  #GGraph.set_map "coast_world"=>true, 'grid'=>false
  GGraph.set_axes('xlabelint'=>30)
  #GGraph.set_axes('ylabelint'=>30)

  GGraph.tone    gpout, true , 'exchange'=>false,
                 'title'=>vnames_bk, 
                 'map_axes'=>true, 'annotate'=>false,
                 'log'=>flag_cntlog, 
                 'nlev'=>15, 'keep'=>true
#                 'min'=>cntmin, 'max'=>cntmax #, 'lev'=>levels, 'pat'=>patterns
  GGraph.contour gpout, false, 'exchange'=>false,
                 'log'=>flag_cntlog, 
                 'nlev'=>15, 'keep'=>true
#                 'min'=>cntmin, 'max'=>cntmax #, 'lev'=>levels
  GGraph.color_bar

  if nLoop > 1 then
    title = (loop_index+1).to_s + "/" + nLoop.to_s
    DCL::uxmttl('T', ' '  , 1.0)
    DCL::uxmttl('T', title, -1.0)
  end
end

DCL.grcls
